﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ColumnScrolledOutIOfView
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        bool messagePopped = false;

        public MainWindow()
        {
            InitializeComponent();
            xamGrid1.DataSource = CreateData();
        }

        private ObservableCollection<Data> CreateData()
        {
            var dataCollection = new ObservableCollection<Data>();
            dataCollection.Add(new Data("data1", "data2", "data3", "data4", "data5", "data6", "data7", "data8", "data9", "data10", "data11", "data12", "data13"));
            dataCollection.Add(new Data("data1", "data2", "data3", "data4", "data5", "data6", "data7", "data8", "data9", "data10", "data11", "data12", "data13"));
            dataCollection.Add(new Data("data1", "data2", "data3", "data4", "data5", "data6", "data7", "data8", "data9", "data10", "data11", "data12", "data13"));
            dataCollection.Add(new Data("data1", "data2", "data3", "data4", "data5", "data6", "data7", "data8", "data9", "data10", "data11", "data12", "data13"));
            dataCollection.Add(new Data("data1", "data2", "data3", "data4", "data5", "data6", "data7", "data8", "data9", "data10", "data11", "data12", "data13"));       
            return dataCollection;
        }
        private void xamGrid1_CellsInViewChanged(object sender, Infragistics.Windows.DataPresenter.Events.CellsInViewChangedEventArgs e)
        {
            var collection = e.CurrentCellsInView;
            var fields = collection[0].Fields;
            var isInView = false;
            
            var match = fields.Where(f => f.Label.ToString() == "data3").ToList();

            if (match.Count > 0)
            {
                isInView = true;
                if (messagePopped) messagePopped=false;
            }
            else isInView = false;
                
            if(!isInView)            
            {
                if (!messagePopped)
                {
                    MessageBox.Show("Column Data3 not in view anylonger");
                    messagePopped = true;
                }
            }
        }
    }
}
